package com.fp.persistence.pcustomer.people;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.sql.Timestamp;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.GeneratedValue;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.persistence.Version;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

/**
 * Clase que implementa la entidad de Hibernate que hace referencia a la tabla TCUSTPEOPLEASSOCIATION
 */
@Entity(name = "TcustPeopleAssociation")
@Table(name = "TCUSTPEOPLEASSOCIATION")
public class TcustPeopleAssociation extends com.fp.dto.AbstractDataTransport implements Serializable, HibernateBean, Cloneable, Log {

    /**
     * HashCode asociado con la Instancia
     */
    @Transient
    private int hashValue = 0;

    /**
     * Version de la Clase
     */
    private static final long serialVersionUID = 1L;

    /**
     * Clave primaria de la Entidad TcustPeopleAssociation
     */
    @EmbeddedId
    @GenericGenerator(name = "seq_id", strategy = "com.fp.general.keygen.SubSequenceKey", parameters = {
            @Parameter(name = "sql", value = "select coalesce(max(ASSOCIATIONSEQUENCE),0)+1 from TCUSTPEOPLEASSOCIATION where personcode=:code"),
            @Parameter(name = "type", value = "java.lang.Integer"), @Parameter(name = "param", value = "code,pk.personcode"),
            @Parameter(name = "field", value = "associationsequence") })
    @GeneratedValue(generator = "seq_id")
    private TcustPeopleAssociationKey pk;

    @Column(name = "ASSOCIATIONPERSONCODE", nullable = true)
    /**
     * Codigo de persona asiganado a la asociacion
     */
    private Integer associationpersoncode;

    @Column(name = "DATEFROM", nullable = true)
    /**
     * Fecha desde la cual esta vigente el registro
     */
    private Timestamp datefrom;

    @Version
    @Column(name = "RECORDVERSION", nullable = true)
    /**
     * Optimistic locking del registro
     */
    private Integer recordversion;

    @Column(name = "ASSOCIATIONNAME", nullable = true)
    /**
     * Nombre de la asociacion cuando no esta definida como una persona
     */
    private String associationname;

    @Column(name = "ASSOCIATIONCODE", nullable = true)
    /**
     * Codigo de registro o de asociacion de la persona
     */
    private String associationcode;

    @Column(name = "INGRESSUSER", nullable = true)
    /**
     * Codigo de usuario que crea el cliente
     */
    private String ingressuser;

    @Column(name = "MODIFYUSER", nullable = true)
    /**
     * Codigo de usuario que modifica datos del cliente
     */
    private String modifyuser;

    /**
     * Contructor por defecto
     */
    public TcustPeopleAssociation() {
    }

    /**
     * Contructor de TcustPeopleAssociation
     * 
     * @param pPk Clave Primaria del entity
     */
    public TcustPeopleAssociation(TcustPeopleAssociationKey pPk) {
        this();
        this.pk = pPk;
    }

    /**
     * Metodo que entrega datos de la tabla dada la clave primaria.
     * 
     * @param pEntityManager referencia de la session a obtener datos del bean.
     * @param pKey Caleve primaria del bean.
     * @return TcustPeopleAssociation
     */
    public static TcustPeopleAssociation find(EntityManager pEntityManager, TcustPeopleAssociationKey pKey) throws Exception {
        TcustPeopleAssociation obj = pEntityManager.find(TcustPeopleAssociation.class, pKey);
        return obj;
    }

    /**
     * Entrega la Clave primaria de TcustPeopleAssociation
     * 
     * @return El objeto que referencia a la Clave primaria de TcustPeopleAssociation
     */
    public TcustPeopleAssociationKey getPk() {
        return this.pk;
    }

    /**
     * Fija un nuevo valor a la Clave primaria de TcustPeopleAssociation
     * 
     * @param pPk El objeto que referencia a la nueva Clave primaria de TcustPeopleAssociation
     */
    public void setPk(TcustPeopleAssociationKey pPk) {
        this.pk = pPk;
    }

    /**
     * Obtiene el valor de associationpersoncode
     * 
     * @return valor de associationpersoncode
     */
    public Integer getAssociationpersoncode() {
        return this.associationpersoncode;
    }

    /**
     * Fija el valor de associationpersoncode
     * 
     * @param pAssociationpersoncode nuevo Valor de associationpersoncode
     */
    public void setAssociationpersoncode(Integer pAssociationpersoncode) {
        this.associationpersoncode = pAssociationpersoncode;
    }

    /**
     * Obtiene el valor de datefrom
     * 
     * @return valor de datefrom
     */
    public Timestamp getDatefrom() {
        return this.datefrom;
    }

    /**
     * Fija el valor de datefrom
     * 
     * @param pDatefrom nuevo Valor de datefrom
     */
    public void setDatefrom(Timestamp pDatefrom) {
        this.datefrom = pDatefrom;
    }

    /**
     * Obtiene el valor de recordversion
     * 
     * @return valor de recordversion
     */
    public Integer getRecordversion() {
        return this.recordversion;
    }

    /**
     * Fija el valor de recordversion
     * 
     * @param pRecordversion nuevo Valor de recordversion
     */
    public void setRecordversion(Integer pRecordversion) {
        this.recordversion = pRecordversion;
    }

    /**
     * Obtiene el valor de associationname
     * 
     * @return valor de associationname
     */
    public String getAssociationname() {
        return this.associationname;
    }

    /**
     * Fija el valor de associationname
     * 
     * @param pAssociationname nuevo Valor de associationname
     */
    public void setAssociationname(String pAssociationname) {
        this.associationname = pAssociationname;
    }

    /**
     * Obtiene el valor de associationcode
     * 
     * @return valor de associationcode
     */
    public String getAssociationcode() {
        return this.associationcode;
    }

    /**
     * Fija el valor de associationcode
     * 
     * @param pAssociationcode nuevo Valor de associationcode
     */
    public void setAssociationcode(String pAssociationcode) {
        this.associationcode = pAssociationcode;
    }

    /**
     * Obtiene el valor de ingressuser
     * 
     * @return valor de ingressuser
     */
    public String getIngressuser() {
        return this.ingressuser;
    }

    /**
     * Fija el valor de ingressuser
     * 
     * @param pIngressuser nuevo Valor de ingressuser
     */
    public void setIngressuser(String pIngressuser) {
        this.ingressuser = pIngressuser;
    }

    /**
     * Obtiene el valor de modifyuser
     * 
     * @return valor de modifyuser
     */
    public String getModifyuser() {
        return this.modifyuser;
    }

    /**
     * Fija el valor de modifyuser
     * 
     * @param pModifyuser nuevo Valor de modifyuser
     */
    public void setModifyuser(String pModifyuser) {
        this.modifyuser = pModifyuser;
    }

    @Override
    public boolean equals(Object rhs) {
        if (rhs == null) {
            return false;
        }
        if (!(rhs instanceof TcustPeopleAssociation)) {
            return false;
        }
        TcustPeopleAssociation that = (TcustPeopleAssociation) rhs;
        if ((this.getPk() == null) || (that.getPk() == null)) {
            return false;
        }
        return (this.getPk().equals(that.getPk()));
    }

    /**
     * Implementaci�n del metodo hashCode de la la entidad TcustPeopleAssociation
     * 
     * @return el hashCode la instancia
     */
    @Override
    public int hashCode() {
        if (this.hashValue == 0) {
            int result = 17;
            if (this.getPk() == null) {
                result = super.hashCode();
            } else {
                result = this.getPk().hashCode();
            }
            this.hashValue = result;
        }
        return this.hashValue;
    }

    /**
     * Implementaci�n toString
     */
    @Override
    public String toString() {
        Field[] fs = this.getClass().getDeclaredFields();
        String data = "";
        for (Field f : fs) {
            try {
                String name = f.getName();
                if (f.getType().getName().compareTo("java.util.Set") == 0) {
                    continue;
                }
                if ((name.compareTo("hashValue") == 0) || (name.compareTo("serialVersionUID") == 0)) {
                    continue;
                }
                data += name + "=" + f.get(this) + ";";
            } catch (Exception e) {
                continue;
            }
        }
        if (data.compareTo("") == 0) {
            data = super.toString();
        }
        return data;
    }

    /**
     * Implementaci�n de la creaci�n de un bean en blanco TcustPeopleAssociation
     */
    @Override
    public Object createInstance() {
        TcustPeopleAssociation instance = new TcustPeopleAssociation();
        instance.setPk(new TcustPeopleAssociationKey());
        return instance;
    }

    /**
     * Clona la entidad TcustPeopleAssociation
     * 
     * @see com.fp.dto.hb.HibernateBean#cloneMe()
     */
    @Override
    public Object cloneMe() throws CloneNotSupportedException {
        TcustPeopleAssociation p = (TcustPeopleAssociation) this.clone();
        p.setPk((TcustPeopleAssociationKey) this.pk.cloneMe());
        return p;
    }

    public Object getId() {
        return this.pk;
    }
}
